"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var nil = exports.nil = "";

var escape = function escape(segment) {
  return segment.toString().replace("~", "~0").replace("/", "~1");
};
var unescape = function unescape(segment) {
  return segment.toString().replace("~0", "~").replace("~1", "/");
};

var decons = exports.decons = function decons(pointer) {
  var ndx = pointer.indexOf("/", 1);

  var _ref = ndx === -1 ? [pointer.slice(1), nil] : [pointer.slice(1, ndx), pointer.slice(ndx)],
      _ref2 = _slicedToArray(_ref, 2),
      segment = _ref2[0],
      remainingPointer = _ref2[1];

  return [unescape(segment), remainingPointer];
};

var cons = exports.cons = function cons(head, tail) {
  return "/" + escape(head) + tail;
};

var append = exports.append = function append(pointer, segment) {
  return pointer + "/" + escape(segment);
};

var get = exports.get = function get(value) {
  var pointer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : nil;

  if (pointer === nil) {
    return value;
  } else {
    var _decons = decons(pointer),
        _decons2 = _slicedToArray(_decons, 2),
        segment = _decons2[0],
        remainingPointer = _decons2[1];

    return get(value[segment], remainingPointer);
  }
};